%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Wenneker Article
% Structure Specification File
% Version 1.0 (28/2/17)
%
% This file originates from:
% http://www.LaTeXTemplates.com
%
% Original Authors:
% Frits Wenneker
% Vel (vel@LaTeXTemplates.com)
%
% Adaptation:
% Frankin Coêlho (franklinanthony@eng.ci.ufpb.br)
% Eudisley Anjos (eudisley@ci.ufpb.br)
%
% License:
% CC BY-NC-SA 3.0 (http://creativecommons.org/licenses/by-nc-sa/3.0/)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%----------------------------------------------------------------------------------------
%	PACKAGES AND OTHER DOCUMENT CONFIGURATIONS
%----------------------------------------------------------------------------------------

% CI logo colors

\usepackage[english]{babel} % English language hyphenation

%\usepackage{authblk}} %Added by Eudis

\usepackage{microtype} % Better typography

\usepackage{siunitx}

\usepackage{soul}

\usepackage{amsmath,amsfonts,amsthm,bm} % Math packages for equations

\usepackage[svgnames]{xcolor} % Enabling colors by their 'svgnames'
\definecolor{blueCI}{rgb}{0.0, 0.2, 0.4}
\definecolor{blackCI}{rgb}{0.086, 0.13,0.16}

\usepackage{tikz}

\usepackage{adjustbox}

\usepackage[hang, small, labelfont=bf, up, textfont=it]{caption} % Custom captions under/above tables and figures

\usepackage{booktabs} % Horizontal rules in tables

\usepackage{lastpage} % Used to determine the number of pages in the document (for "Page X of Total")

\usepackage{graphicx} % Required for adding images
\graphicspath{ {./img/} }

%\usepackage{subfigure}

\usepackage{subcaption}
\captionsetup{format=default,justification=justified,singlelinecheck=false}
\captionsetup[sub]{justification=raggedleft,singlelinecheck=false}

\usepackage{tabularx}

\usepackage{multirow}

\usepackage{enumitem} % Required for customising lists
\setlist{noitemsep} % Remove spacing between bullet/numbered list elements

\usepackage{sectsty} % Enables custom section titles
\allsectionsfont{\scshape \color{blackCI}} % Change the font of all section commands (Helvetica)

\usepackage[colorlinks,linkcolor=blueCI,urlcolor=blueCI,citecolor=blueCI]{hyperref}
\urlstyle{same} % same font as text

\usepackage{lipsum}

%\usepackage[acronym]{glossaries}
\usepackage[toc,acronym]{glossaries}



%Define the listing package
\usepackage{listings} %code highlighter
\usepackage{color} %use color
\definecolor{mygreen}{rgb}{0,0.6,0}
\definecolor{mygray}{rgb}{0.5,0.5,0.5}
\definecolor{mymauve}{rgb}{0.58,0,0.82}

%Customize a bit the look
\lstset{ %
	inputpath={ {./code/} },
	backgroundcolor=\color{white}, % choose the background color; you must add \usepackage{color} or \usepackage{xcolor}
	basicstyle=\footnotesize, % the size of the fonts that are used for the code
	breakatwhitespace=false, % sets if automatic breaks should only happen at whitespace
	breaklines=true, % sets automatic line breaking
	captionpos=b, % sets the caption-position to bottom
	commentstyle=\color{mygreen}, % comment style
	deletekeywords={...}, % if you want to delete keywords from the given language
	escapeinside={\%*}{*)}, % if you want to add LaTeX within your code
	extendedchars=true, % lets you use non-ASCII characters; for 8-bits encodings only, does not work with UTF-8
	frame=single, % adds a frame around the code
	keepspaces=true, % keeps spaces in text, useful for keeping indentation of code (possibly needs columns=flexible)
	keywordstyle=\color{blue}, % keyword style
	% language=Octave, % the language of the code
	morekeywords={*,...}, % if you want to add more keywords to the set
	numbers=left, % where to put the line-numbers; possible values are (none, left, right)
	numbersep=5pt, % how far the line-numbers are from the code
	numberstyle=\tiny\color{mygray}, % the style that is used for the line-numbers
	rulecolor=\color{black}, % if not set, the frame-color may be changed on line-breaks within not-black text (e.g. comments (green here))
	showspaces=false, % show spaces everywhere adding particular underscores; it overrides 'showstringspaces'
	showstringspaces=false, % underline spaces within strings only
	showtabs=false, % show tabs within strings adding particular underscores
	stepnumber=1, % the step between two line-numbers. If it's 1, each line will be numbered
	stringstyle=\color{mymauve}, % string literal style
	tabsize=2, % sets default tabsize to 2 spaces
	title=\lstname % show the filename of files included with \lstinputlisting; also try caption instead of title
}
%END of listing package%

\definecolor{darkgray}{rgb}{.4,.4,.4}
\definecolor{purple}{rgb}{0.65, 0.12, 0.82}

%define Javascript language
\lstdefinelanguage{JavaScript}{
	keywords={typeof, new, true, false, catch, function, return, null, catch, switch, var, let, const, if, in, while, do, else, case, break},
	keywordstyle=\color{blue}\bfseries,
	ndkeywords={class, export, boolean, throw, implements, import, this},
	ndkeywordstyle=\color{darkgray}\bfseries,
	identifierstyle=\color{black},
	sensitive=false,
	comment=[l]{//},
	morecomment=[s]{/*}{*/},
	commentstyle=\color{purple}\ttfamily,
	stringstyle=\color{red}\ttfamily,
	morestring=[b]',
	morestring=[b]"
}

\lstset{
	language=JavaScript,
	extendedchars=true,
	basicstyle=\footnotesize\ttfamily,
	showstringspaces=false,
	showspaces=false,
	numbers=left,
	numberstyle=\footnotesize,
	numbersep=9pt,
	tabsize=2,
	breaklines=true,
	showtabs=false,
	captionpos=b
}

\makeatletter
\newcommand\BeraMonottfamily{%
	\def\fvm@Scale{0.85}% scales the font down
	\fontfamily{fvm}\selectfont% selects the Bera Mono font
}
\makeatother

%----------------------------------------------------------------------------------------
%	THEOREMS AND DEFINITIOSN
%----------------------------------------------------------------------------------------

\newtheorem{trilemma}{Trilemma}[section]
\newtheorem{theorem}{Theorem}[section]

%----------------------------------------------------------------------------------------
%	MARGINS AND SPACING
%----------------------------------------------------------------------------------------

\usepackage{geometry} % Required for adjusting page dimensions

\geometry{
	top=1.cm, % Top margin
	bottom=1.5cm, % Bottom margin
	left=2cm, % Left margin
	right=2cm, % Right margin
	includehead, % Include space for a header
	includefoot, % Include space for a footer
%	showframe, % Uncomment to show how the type block is set on the page
}

\setlength{\columnsep}{7mm} % Column separation width

%----------------------------------------------------------------------------------------
%	FONTS
%----------------------------------------------------------------------------------------

\usepackage[T1]{fontenc} % Output font encoding for international characters
\usepackage[utf8]{inputenc} % Required for inputting international characters

\usepackage[sfdefault,scaled=.85]{FiraSans}
\usepackage{newtxsf}

\usetikzlibrary{arrows,positioning,calc,intersections,arrows.meta,decorations.pathreplacing,decorations.pathmorphing,shapes}
%----------------------------------------------------------------------------------------
%	HEADERS AND FOOTERS
%----------------------------------------------------------------------------------------

\usepackage{fancyhdr} % Needed to define custom headers/footers
\pagestyle{fancy} % Enables the custom headers/footers

\renewcommand{\headrulewidth}{0.0pt} % No header rule
\renewcommand{\footrulewidth}{0.4pt} % Thin footer rule

\renewcommand{\sectionmark}[1]{\markboth{#1}{}} % Removes the section number from the header when \leftmark is used

%\nouppercase\leftmark % Add this to one of the lines below if you want a section title in the header/footer

% Headers
\lhead{\includegraphics[scale=0.1]{placeholder-logo} \hspace{0.1cm} \textbf{\scshape\leftmark}} % Left header
\chead{} % Center header - currently printing the article title
\rhead{} % Right header
%\textit{\thetitle}

% Footers
\lfoot{} % Left footer
\cfoot{} % Center footer
\rfoot{\footnotesize \thepage}% de \pageref*{LastPage}} % Right footer, "Page 1 of 2"

\fancypagestyle{firstpage}{ % Page style for the first page with the title
	\fancyhf{}
	\renewcommand{\footrulewidth}{0pt} % Suppress footer rule
}

%----------------------------------------------------------------------------------------
%	TITLE SECTION
%----------------------------------------------------------------------------------------

\newcommand{\authorstyle}[1]{\large\color{blackCI}#1} % Authors style (Helvetica)

\newcommand{\institution}[1]{\footnotesize\usefont{OT1}{phv}{m}{sl}\color{blackCI}#1} % Institutions style (Helvetica)

\usepackage{titling} % Allows custom title configuration

\newcommand{\HorRule}{\color{blueCI}\rule{\linewidth}{2pt}} % Defines the horizontal rule around the title

\newcommand{\TITFONT}{28}

\newcommand{\email}[1]{\normalsize\href{mailto:#1}{#1}\par}

\pretitle{
	\null\hfill \includegraphics[scale=0.2]{placeholder-logo} \\ \\
	\centering \vspace{10pt} % Move the entire title section up
	\centering \HorRule\vspace{20pt} % Horizontal rule before the title
	\centering \fontsize{\TITFONT}{1.2\TITFONT}\usefont{OT1}{phv}{b}{n}\selectfont % Helvetica
	\centering \color{blackCI} % Text colour for the title and author(s)
}

\posttitle{\par\vskip 15pt} % Whitespace under the title

\preauthor{} % Anything that will appear before \author is printed

\postauthor{ % Anything that will appear after \author is printed
        \centering \vspace{6pt} % Space before the rule
        \centering \footnotesize \textbf{
%        Relatore Discipline,\\
%		Diperimento di Scienze Informatiche\\
%		University of Bologna
        }
        \vspace{2pt} % Space after the title section
    	\par\HorRule \\ % Horizontal rule after the title
    	\vspace{2pt} % Space after the title section
}

%----------------------------------------------------------------------------------------
%	ABSTRACT
%----------------------------------------------------------------------------------------

\usepackage{lettrine} % Package to accentuate the first letter of the text (lettrine)
\usepackage{fix-cm}	% Fixes the height of the lettrine

\newcommand{\initial}[1]{ % Defines the command and style for the lettrine
	\lettrine[lines=2,findent=4pt,nindent=0pt]{% Lettrine takes up 3 lines, the text to the right of it is indented 4pt and further indenting of lines 2+ is stopped
		\color{blackCI}% Lettrine colour
		{#1}% The letter
	}{}%
}

\usepackage{xstring} % Required for string manipulation

\newcommand{\lettrineabstract}[1]{\color{blackCI}
	\StrLeft{#1}{1}[\firstletter] % Capture the first letter of the abstract for the lettrine
	\initial{\firstletter}\textbf{\StrGobbleLeft{#1}{1}} % Print the abstract with the first letter as a lettrine and the rest in bold
}

%----------------------------------------------------------------------------------------
%	DRAW MACROS
%----------------------------------------------------------------------------------------

\tikzset{
	>=stealth',
	stackblackrectangle/.style={
		rectangle, 
		rounded corners,
		draw=black, very thick,
		text width=4cm,
		fill=black!10,
		minimum height=1cm, 
		text centered},
	stackwhiterectangle/.style={
		rectangle, 
		rounded corners,
		draw=black, very thick,
		text width=4cm,
		minimum height=1cm, 
		text centered},
	stackwhiterectangle2/.style={
		rectangle, 
		rounded corners,
		draw=black, thick,
		text width=9cm,
		minimum height=1.7cm,
		text centered},
	dapprectangle/.style={
		rectangle, 
		rounded corners,
		draw=black, very thick,
		text width=5cm,
		minimum height=1cm, 
		text centered},
	dappblackrectangle/.style={
		rectangle, 
		rounded corners,
		draw=black, very thick,
		text width=5cm,
		fill=black!10,
		minimum height=1cm, 
		text centered},
	dappblackrectangle2/.style={
		rectangle, 
		rounded corners,
		draw=black, very thick,
		text width=2cm,
		fill=black!10,
		minimum height=1cm, 
		text centered},
	whiterectangle/.style={
		rectangle, 
		rounded corners,
		draw=black, very thick,
		text width=3cm,
		minimum height=1cm, 
		text centered},
	hash/.style={
		rectangle, 
		rounded corners,
		draw=black, thick,
		text width=1cm,
		minimum height=0.7cm, 
		text centered},
	quadro/.style={
		rectangle, 
		rounded corners,
		draw=black, thick,
		fill=black!10,
		text width=0.7cm,
		minimum height=0.7cm, 
		text centered},
	1whiterectangle/.style={
		rectangle, 
		rounded corners,
		draw=black, very thick,
		text width=4cm,
		minimum height=1cm, 
		text centered},
	1grayrectangle/.style={
		rectangle, 
		rounded corners,
		draw=black, very thick,
		text width=4cm,
		fill=black!10,
		minimum height=1cm, 
		text centered},
	grayrectangle/.style={
		rectangle, 
		rounded corners, 
		fill=black!10,
		draw=black, very thick,
		text width=2.8cm,
		minimum height=1cm, 
		text centered},
	line/.style={draw, thick, <-},
	rhomboid/.style={
		diamond,
		draw=black, very thick,
		text width=1.5cm,
		minimum height=1cm, 
		text centered},
	line/.style={draw, thick, <-},
	roundfigure/.style={
		circle, 
		rounded corners, 
		fill=black!10,
		draw=black, very thick,
		text width=0.8cm,
		minimum height=1cm, 
		text centered},
	whiteroundfigure/.style={
		circle, 
		rounded corners, 
		draw=black, very thick,
		text width=.9cm,
		minimum height=1cm, 
		text centered},
	line/.style={draw, thick, <-},
	element/.style={
		tape,
		top color=white,
		bottom color=blue!50!black!60!,
		minimum width=8em,
		draw=blue!40!black!90, very thick,
		text width=10cm, 
		minimum height=3.5cm, 
		text centered},
	every join/.style={->, thick,shorten >=1pt},
	decoration={brace},
	tuborg/.style={decorate,very thick},
	tubnode/.style={midway, right=2pt},
}


%----------------------------------------------------------------------------------------
%	BIBLIOGRAPHY
%----------------------------------------------------------------------------------------

\renewcommand{\refname}{\normalsize{Bib}}

\usepackage[backend=biber,natbib=true]{biblatex} 

\addbibresource{refs.bib} % The filename of the bibliography

\usepackage[autostyle=true]{csquotes} % Required to generate language-dependent quotes in the bibliography

\usepackage{float} % Force the figure to stay where it was determined

\usepackage{nomencl} % List of symbols

\usepackage{attrib}

\usepackage{listings}
